/*
 * SnakeMatrix.java
 *
 * Created on July 21, 2005, 4:48 AM
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

package snakeserver;

import java.util.*;


/**
 *
 * @author Administrator
 */
public class SnakeMatrix {
    
    public Snake [] snakes;
    
    public Vector food = new Vector();
    
    public int numsnakes;
    
    int sUP = 0;
    int sRIGHT = 1;
    int sDOWM = 2;
    int sLEFT = 3;
    
    /** Creates a new instance of SnakeMatrix */
    public SnakeMatrix() {
        
        numsnakes = 0;
        snakes = new Snake[200];
        //snakes = new Vector(10);
        makeRandomFood();
     
    }
    
    public void moveAllSnakes()
    {
        //move all of the snakes one space.
        
        for(int cursnake=0; cursnake<numsnakes; cursnake++)
        {
            snakes[cursnake].moveWholeSnakeOneSpace();
            //collision checking (dead snake!)
            checkCollisions(cursnake);
            checkFood(cursnake);
            
            
        }
        checkToSeeIfWeNeedToMakeFood();
    }
    private void checkToSeeIfWeNeedToMakeFood(){
        
        if (food.size() <= 0)
            makeRandomFood();
        
    }
    private void checkFood(int cursnake){
        //if the head of the current snake deserves food, give it to him!
        SnakePiece head = snakes[cursnake].getSnakePiece(0);
        int food_initialsize = food.size();
        for(int foodpieceindex=0; foodpieceindex < food_initialsize ; foodpieceindex++)
        {
            SnakePiece curfoodpiece = (SnakePiece)food.get(foodpieceindex);
            if ((head.x == curfoodpiece.x) && (head.y == curfoodpiece.y))
            {
                snakes[cursnake].setDeservesFood(true); //get food on the next move
                //TODO: maybe incriment score later
                
                //erase that piece of food!
                food.removeElementAt(foodpieceindex);
             
                return;
            }
        }
        
        
        
    }
   private void checkCollisions(int cursnakeid){
       //check for collisions
       if(checkWallCollide(cursnakeid))
       {
           //snake ran into wall
           snakes[cursnakeid].setNewRandomCoordsAndDirection();
       }
       else if(checkOtherSnakeCollide(cursnakeid))
       {
           //snake ran into another snake
           snakes[cursnakeid].setNewRandomCoordsAndDirection();
       }
       else if(checkSelfCollide(cursnakeid))
       {
           //snake ran into itself
           snakes[cursnakeid].setNewRandomCoordsAndDirection();
           
       }
   }


   private boolean checkSelfCollide(int cursnakeid){
       //see if the head of the snake has collided with its body
        SnakePiece head = snakes[cursnakeid].getSnakePiece(0);
        SnakePiece bodyPiece;
        
        for(int snakepieceid = 1; snakepieceid < snakes[cursnakeid].getSize(); snakepieceid++)
        {
            //see if our snake's head matches any part of its body
            bodyPiece = snakes[cursnakeid].getSnakePiece(snakepieceid);
            
            if((head.x == bodyPiece.x) && (head.y == bodyPiece.y))
            {
                return true;
            }
        }
        
        return false;
       
        /*
        
        for(int othersnakeid=0;othersnakeid < numsnakes; othersnakeid++)
        {
            if (cursnakeid != othersnakeid)
            {
                for(int othersnakepieceid = 0; othersnakepieceid < snakes[othersnakeid].getSize(); othersnakepieceid++)
                {
                    //see if our snake's head matches any part of the current snakes body
                    otherSnakePiece = snakes[othersnakeid].getSnakePiece(othersnakepieceid);
                    if((head.x == otherSnakePiece.x) && (head.y == otherSnakePiece.y))
                    {
                        return true;
                    }
                }
                
                
            }
        }
        return false;
         */
   }

   private boolean checkOtherSnakeCollide(int cursnakeid){
       //see if the head of the current snake has collided with any other snakes
        SnakePiece head = snakes[cursnakeid].getSnakePiece(0);
        SnakePiece otherSnakePiece;
        for(int othersnakeid=0;othersnakeid < numsnakes; othersnakeid++)
        {
            if (cursnakeid != othersnakeid)
            {
                for(int othersnakepieceid = 0; othersnakepieceid < snakes[othersnakeid].getSize(); othersnakepieceid++)
                {
                    //see if our snake's head matches any part of the current snakes body
                    otherSnakePiece = snakes[othersnakeid].getSnakePiece(othersnakepieceid);
                    if((head.x == otherSnakePiece.x) && (head.y == otherSnakePiece.y))
                    {
                        return true;
                    }
                }
                
                
            }
        }
        return false;
   }
   private boolean checkWallCollide(int cursnakeid){
       //see if the head of the snake has gone out of bounds
       
       SnakePiece head = snakes[cursnakeid].getSnakePiece(0);
       
       //check x and y boundaries
       if ((head.x > ProgramConstants.boardMaxX) || (head.x < 0) ||
           (head.y > ProgramConstants.boardMaxY) || (head.y < 0))
       {
           //snake ran into wall
           return true;
       }
       return false;
           
   }
    
    public void changeDirection(String snakeIP, int newDirection)
    {
            
        //if the direction is a valid UP, DOWN, LEFT, or RIGHT direciton,
        // alter the snake's direction
        
        if((newDirection==0) || (newDirection==1) || (newDirection==2) || (newDirection==3))
        {
            
            //find the snake in the map
            //if(snakes.get(snakeIP)==null)
            int snakeID = getSnakeID(snakeIP);
            if(snakeID == -1)
            {
                //this snake hasn't been created yet in the map.  create it and 
                // put it into the map.
                snakeID = numsnakes;
                numsnakes++;
                snakes[snakeID] = new Snake(snakeIP);
                               
                //give the new snake random coordinates
                snakes[snakeID].setNewRandomCoordsAndDirection();
                
                

            }
            else
            {
                //change the snake's direction
                snakes[snakeID].setDirection(newDirection);
            }
             
        }
        else
        {
            //bad snake direction command, do nothing
           
        }


    }
    
    private int getSnakeID(String IP)
    {
        //return the first occurance of the index that has the cooresponding IP
        
        for(int x=0;x<numsnakes;x++)
            if (snakes[x].ip.equals(IP))
                return x;
       
        return(-1);         
    }
    public void makeRandomFood(){
        food.clear();
        for(int x=0; x < ProgramConstants.numFoodPieces; x++)
        {
            food.add(Snake.makeRandomSnakePiece());
        }
        
    }
    

}
